// Definicija klase kvadrata (Kvadrat).

#ifndef __kvadrat__h__
#define __kvadrat__h__

#include "figura.h"

class Kvadrat : public Figura {
  Real a;                                  // Osnovica.
public:
  Kvadrat (Real aa=1, Tacka tt=ORG) : a (aa) { T = tt; }
  Real d () const { return a * 1.414213562373; } // Dijagonala.
  Real O () const { return 4 * a; }        // Obim.
  Real P () const { return a * a; }        // Povrsina.
  Real r () const { return a / 2; }        // Poluprecnik upisanog kruga.
  Real R () const { return d () / 2; }     // Poluprecnik opisanog kruga.
private:
  istream &citaj (istream &dd) ;           // Citanje.
  ostream &pisi  (ostream &dd) const ;     // Pisanje.
} ;

#endif
