// Definicije uz klasu Stek.

#include "stek1.h"
#include <stdlib.h>

Stek *Stek::vrh = 0;           // Definicija vrh-a sa inicijalizacijom.

void Stek::dodaj (int i) {     // Dodavanje novog podatka na stek:
  Stek *novi  = new Stek;      //   - dodela memorije,
  if (! novi) exit (1);        //   - prekid programa ako nije uspela,
  novi->broj  = i;             //   - smestanje podatka u element,
  novi->preth = vrh;           //   - ukljucivanje elementa u listu.
  vrh = novi;
}

int Stek::uzmi () {            // Uzimanje podatka sa vrha steka:
  if (! vrh) exit (2);         //   - prekid programa ako je stek prazan,
  int i = vrh->broj;           //   - pamcenje podatka sa vrha steka,
  Stek *stari = vrh;           //   - iskljucivanje elementa iz liste,
  vrh = vrh->preth;
  delete stari;                //   - oslobadjanje dodeljene memorije,
  return i;                    //   - vracanje upamcenog podatka.
}

void Stek::brisi () { while (vrh) uzmi (); }  // Praznjenje steka.
