#include <iostream.h>

class String {
  char *niz;                          // Pokazivac na sam tekst.
public:
  String () { niz = 0; }              // Inicijalizacija praznog niza.
  String (const char *) ;             // Inicijalizacija nizom znakova.
  String (const String &) ;           // Inicijalizacija tipom String.
  String operator= (const String &) ; // Dodela vrednosti.
  ~String () ;                        // Unistavanje objekta tipa String.
  friend ostream & operator<< (ostream &, const String &) ;
} ;

#include <string.h>

String::String (const char *t)
  { if (niz = new char [strlen(t)+1]) strcpy (niz, t); }

String::~String () { delete [] niz; niz = 0; }

String::String (const String &s)
  { if (niz = new char [strlen(s.niz)+1]) strcpy (niz, s.niz); }

String String::operator= (const String &s) {
  if (&s != this) {
    delete [] niz;
    if (niz = new char [strlen(s.niz)+1]) strcpy (niz, s.niz);
  }
  return *this;
}

ostream & operator<< (ostream &d, const String &s)
  { return d << s.niz; }

void main () {
  String pozdrav ("Pozdrav svima");   // Poziva se String (char *).
  String a = pozdrav;                 // Poziva se String (String &).
  String b;                           // Poziva se String ().
  b = a;                              // Poziva se operator= (String &).
  cout << "pozdrav = " << pozdrav << endl
       << "a       = " << a       << endl
       << "b       = " << b       << endl;
}
