// Definicija klase trouglova (Trougao).

#ifndef __trougao__h__
#define __trougao__h__

#include "figura.h"

class Trougao : public Figura {
  Real a, b, c;                            // Strane.
public:                                    // Konstruktori:
  Trougao () : a(1), b(1), c(1) { T = ORG; }         // jedinicni
  Trougao (Real aa, Tacka tt=ORG)                    // ravnostrani
    { a = b = c = aa; T = tt; }
  Trougao (Real aa, Real bb, Tacka tt=ORG)           // ravnokraki
    { a = aa; b = c = bb; T = tt; }
  Trougao (Real aa, Real bb, Real cc, Tacka tt=ORG)  // opsti
    { a = aa; b = bb; c = cc; T = tt; }
  Real d () const { return -1; }           // Dijagonala (nema smisla).
  Real O () const { return a + b + c; }    // Obim.
  Real P () const ;                        // Povrsina.
  Real r () const ;                        // Poluprecnik upisanog kruga.
  Real R () const ;                        // Poluprecnik opisanog kruga.
private:
  istream &citaj (istream &dd) ;           // Citanje.
  ostream &pisi  (ostream &dd) const ;     // Pisanje.
} ;

#endif
