// Program za ispitivanje klasa za geometrijske figure.

#include "krug.h"
#include "kvadrat.h"
#include "trougao.h"
#include <iostream.h>

void main () {
  struct Elem { Figura *fig; Elem *nar; };
  Elem *prvi=0, *posl=0;
  Figura *pf;

  // Formiranje liste figura citajuci preko glavnog ulaza.
  for (int dalje=1; dalje; ) {
    char ff[2]; cin >> ff;
    switch (ff[0]) {
      case 'o': pf = new Krug;    break;
      case 'k': pf = new Kvadrat; break;
      case 't': pf = new Trougao; break;
      default: dalje = 0;
    }
    if (dalje) {
      cin >> *pf;
      Elem *novi = new Elem; novi->fig = pf; novi->nar = 0;
      if (posl) posl->nar = novi; else prvi = novi;
      posl = novi;
    }
  }

  // Prikazivanje sadrzaja liste na glavnom izlazu.
  for (Elem *tek=prvi; tek; tek=tek->nar) cout << *tek->fig << "\n";

  // Citanje pomeraja za pomeranje figura.
  Real dx, dy; cin >> dx >> dy;
               cout << "\ndx, dy= " << dx << ", " << dy << "\n\n";

  // Pomeranje figura uz ispisivanje na glavnom izlazu.
  for (tek=prvi; tek; tek=tek->nar)
    { tek->fig->pomeri (dx, dy); cout << *tek->fig << "\n"; }
}
