#include <iostream.h>
#include <math.h>

class Kompl {
  double re, im;
public:
  Kompl (double r=0, double i=0) { re=r; im=i; } // Inic. ili konverzija.
  operator double () ;                           // Konverzija u double.
  friend double real (Kompl z) { return z.re; }  // Realni deo.
  friend double imag (Kompl z) { return z.im; }  // Imaginarni deo.
  Kompl operator+ (Kompl) ;                      // Sabiranje.
} ;

Kompl::operator double () { return sqrt (re*re + im*im); }

inline Kompl Kompl::operator+ (Kompl z)
  { Kompl a; a.re = re + z.re; a.im = im + z.im; return a; }

void pisi (char *c, Kompl z)
  { cout << c << " = (" << real (z) << "," << imag (z) << ")\n"; }

void main () {
  Kompl a (1, 2);      pisi ("a      ", a);
  Kompl b = a;         pisi ("b      ", b);
  Kompl c = 5;         pisi ("c      ", c);
                       pisi ("a+b    ", a + b);
                       pisi ("a+3    ", a + (Kompl) 3);
                       pisi ("|a|+3  ", (double) a + 3);
                       pisi ("a+(3,4)", a + Kompl (3,4));
                       cout << "dble(a) = " <<  (double) a << "\n";
  double d=Kompl(3,4); cout << "d       = " << d << "\n";
}
