// Definicija klase krugova (Krug).

#ifndef __krug__h__
#define __krug__h__

#include "figura.h"

static const Real PI = 3.14159265359;

class Krug : public Figura {
  Real ro;                                 // Poluprecnik.
public:
  Krug (const Real rr=1, const Tacka &tt=ORG) // Konstruktor.
    : ro (rr) { T = tt; }
  Real O () const { return 2  * ro * PI; } // Obim.
  Real P () const { return ro * ro * PI; } // Povrsina.
  Real d () const { return 2  * ro; }      // Precnik.
  Real r () const { return ro; }           // Poluprecnik upisanog kruga.
  Real R () const { return ro; }           // Poluprecnik opisanog kruga.
private:
  istream &citaj (istream &dd) ;           // Citanje.
  ostream &pisi  (ostream &dd) const ;     // Pisanje.
} ;

#endif
