// Definicija klase polinoma (Poli).

#include <iostream.h>

class Poli {
  int n; double *a;
public:
  friend Poli poli () ;                               // Prazan polinom.
  friend Poli poli (const double *a, int n) ;         // Polinom od niza.
  friend void niz  (const Poli &p, double *a, int &n);// Niz od polinoma.
  friend int    operator+  (const Poli &p) ;          // Red polinoma.
  friend Poli   operator+  (const Poli &p1, const Poli &p2) ;  // p1 + p2
  friend Poli   operator-  (const Poli &p1, const Poli &p2) ;  // p1 - p2
  friend Poli   operator*  (const Poli &p1, const Poli &p2) ;  // p1 * p2
  double operator() (double x) const ;                         // p(x)
  Poli & operator= (const Poli &p) ;                 // Dodela vrednosti.
  friend istream & operator>> (istream &d, Poli &p) ;// Citanje polinoma.
  friend ostream & operator<< (ostream &d, const Poli &p) ;   // Pisanje.
  void   operator~ () { n=-1; delete [] a; a=0; }// Unistavanje polinoma.
//  ~Poli () { delete [] a; a=0; n=-1; }
//  Poli () { a = 0; n = -1; }
//  Poli (const Poli &p) {
//    if ((n=p.n) >= 0) {
//      a = new double (n+1);
//      for (int i=0; i<=n; i++) a[i] = p.a[i];
//    } else a = 0;
//  }
} ;

inline Poli poli () { Poli p; p.n = -1; p.a = 0; return p; }
inline int operator+ (const Poli &p) { return p.n; }
