// Program za ispitivanje klase Poli.

#include "poli.h"
#include <iostream.h>

void main () {
  // Definisanje tri polinoma i inicijalizacija kao prazni polinomi.
  Poli p1=poli(), p2=poli(), p3=poli(); cout << "\n";

  // Citanje polinoma, aritmeticke operacije i dodela vrednosti.
  cin >> p1 >> p2;
  cout << "p1    = " <<  p1     << "\n";
  cout << "p2    = " <<  p2     << "\n";
  cout << "p1+p2 = " <<  p1+p2  << "\n";
  cout << "p1-p2 = " <<  p1-p2  << "\n";
  cout << "p2-p1 = " <<  p2-p1  << "\n";
  cout << "p1-p1 = " <<  p1-p1  << "\n";
  cout << "p1*p2 = " <<  p1*p2  << "\n";
  cout << "p3=p1 = " << (p3=p1) << "\n";
  cout << "p3    = " <<  p3     << "\n";

  // Unistavanje nepotrebnih polinoma.
  ~p1; ~p2;
  cout << "~p1   = " <<  p1     << "\n";

  // Konverzija polinoma u niz i obrnuto.
  double *a = new double [+p3 + 1]; int n; niz (p3, a, n);
  cout << "a     = ";
    for (int i=n; i>=0; i--) cout << a[i] << " "; cout << "\n";
  cout << "p(a,n)= " << poli (a, n) << "\n";

  // Koriscenje pokazivaca na polinom.
  Poli *pp4 = new Poli (poli (a, n));
  cout << "*pp4  = " <<  *pp4   << "\n";
  ~(*pp4); delete pp4;

  // Tabeliranje polinoma.
  double xmin, xmax, dx;
  cin >> xmin >> xmax >> dx;
  cout << "\nxmin, xmax, dx = "
       << xmin << ", " << xmax << ", " << dx << "\n";
  cout << "\nx\tp3(x)\n================\n";
  for (double x=xmin; x<=xmax; x+=dx) cout << x << "\t" << p3(x) << "\n";
}
