// Definicija klase tacaka (Tacka).

#include <iostream.h>

class Tacka {
  double x, y;           // Koordinate.
public:
  friend istream & operator>> (istream &dd, Tacka &tt) ;      // Citanje.
  friend ostream & operator<< (ostream &dd, const Tacka &tt); // Pisanje.
  friend int operator<(const Tacka &t1, const Tacka &t2);// Uporedivanje.
} ;

inline istream & operator>> (istream &dd, Tacka &tt)          // Citanje.
  { return dd >> tt.x >> tt.y; }

inline ostream & operator<< (ostream &dd, const Tacka &tt)    // Pisanje.
  { return dd << "T(" << tt.x << "," << tt.y << ")"; }

inline int operator< (const Tacka &t1, const Tacka &t2)  // Uporedivanje.
  { return t1.x*t1.x + t1.y*t1.y < t2.x*t2.x + t2.y*t2.y; }
