// Definicija klase tekstova (Tekst).

#include <iostream.h>

class Tekst {
  struct Txt {
    int   kor;                        // Broj koriscenja teksta.
    char *niz;                        // Pokazivac na znakovni niz.
  };
  Txt *txt;                           // Pokazivac na tekst.
  void brisi () ;                     // Brisanje strukture teksta.
public:
  Tekst (const char *n ="") ;         // Inicijalizacija znakovnim nizom.
  Tekst (const Tekst &t) ;            // Inicijalizacija tekstom.
  ~Tekst () { brisi (); }             // Unistavanje.
  Tekst operator= (const Tekst &t) ;          // Dodela vrednosti.
  friend Tekst operator+ (const Tekst &t1,
                          const Tekst &t2) ;  // Spajanje tekstova.
  Tekst operator+= (const Tekst &t);          // Dopisivanje teksta.
  int operator+ () const {return txt ? txt->kor : 0;} // Broj koriscenja.
  friend int len (const Tekst &t) ;                   // Duzina teksta.
  friend istream & operator>> (istream &d, Tekst &t) ;        // Citanje.
  friend ostream & operator<< (ostream &d, const Tekst &t) ;  // Pisanje.
} ;
